<%-- Copyright (c) 2003-2009 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved. --%>
<%@page import="com.sas.solutions.casemgmt.web.util.WebUtil"%>
<%@page import="com.sas.solutions.casemgmt.web.search.SearchModel"%>
<%@ include file="/shell/default.jspf"%>

<%@ taglib uri="http://www.sas.com/cpb/tag" prefix="cpb"%>
<%@ taglib prefix="sas" uri="http://www.sas.com/taglib/sas" %>

<%@ page import="java.util.*"%>
<%@ page import="com.sas.solutions.casemgmt.domain.*"%>
<%@ page import="com.sas.solutions.casemgmt.web.incident.*"%>
<%@ page import="com.sas.solutions.casemgmt.i18n.AppProperties"%>
<%@ page import="com.sas.fsd.shared.util.StringUtil" %>

<sas-cm:setBundle var="appResources" />
<fmt:message var="relatedCaseSection" key="section.related.cases.header.txt" bundle="${appResources}" />
<fmt:message var="relatedIncidentSection" key="section.related.incidents.header.txt" bundle="${appResources}" />

<%
AddIncidentToCaseActionModel model = AddIncidentToCaseActionModel.getFromRequest(request);
%>
<script type="text/javascript">
AddIncidentToCase.FORM_NAME = "<%=StringUtil.escapeJSForHTML(model.getFormName())%>";
AddIncidentToCase.KEY = <%=model.getEntityKey()%>;
</script>

<%@include file="/ext/cpbcore/messages/ShowMessages.jsp" %>
<% model.writeToolBar(pageContext); %>
<html:form action="/AddIncidentToCase">
<div id="mainContent">
   <html:hidden property="key" />
   <html:hidden property="uiContextId" />
   <html:hidden property="viewMode" />
   <html:hidden property="windowLayout" />
   <html:hidden property="command" />
   
   <div id='casesPane' data-dojo-type='dijit/TitlePane'
         data-dojo-props='title: "${relatedCaseSection}"'>
      <input type='hidden' id='selectedResults' name='selectedResults' />
      <div id='caseSearchGridDiv'></div>
   </div>
   
   <div id='incidentsPane' data-dojo-type='dijit/TitlePane'
         data-dojo-props='title: "${relatedIncidentSection}"'>
      <div id='incidentSearchGridDiv'></div>
   </div>
   
   <div class='optionSection'>
      <label>
         <html:checkbox property="autoLinkPartiesFromIncident" value="true" />
         <fmt:message bundle="${appResources}" key="incident.addToCase.autoLinkParties.checkbox.label" />
      </label>
   </div>

<% if (model.isFinancialItemMigrationSupported()) { %>
   <div class='optionSection'>
      <label>
         <html:checkbox property="autoAddFinancialItemsFromIncident" value="true" />
         <fmt:message bundle="${appResources}" key="incident.addToCase.autoLinkFinancialItems.checkbox.label" />
      </label>
   </div>
<% } %>
   </div>
   
<% model.writeButtonBar(); %>
   
</html:form>

<script type='text/javascript'>
   require(['sas-ecm/search/SearchGrid',  'sas-cpb/datagrid/CPBDataGrid', 'dojo/aspect', 'dojo/ready'],
      function(SearchGrid, CPBDataGrid, aspect, ready) {
      ready(function() {
         
         <%
            AddIncidentToCaseForm form = (AddIncidentToCaseForm)session.getAttribute("AddIncidentToCaseForm");
            SearchModel csm = form.getCaseSearchModel();
            String firstColRenderCell = csm.getFirstColumnRenderCell();
         %>
         var columns = <%=csm.getColumnsAsJson()%>;
         var url = 'controller/caseIncidentSearch/case.json';
         var store = CPBDataGrid.createStore('caseSearchGrid', url, true);
         var caseGrid = SearchGrid.create(<%=firstColRenderCell%>, columns, 'caseSearchGridDiv', {
            id: 'caseSearchGrid',
            columns: columns,
            store: store,
            rowsPerPage: <%=WebUtil.getPageSize()%>
         });
         caseGrid.startup();
         
         // OK button should only be enabled when a case is selected
         aspect.after(Search, 'updateSelected', function() {
            dijit.byId('okButton').set('disabled', false);
         });
         
         <%
            SearchModel ism = form.getIncidentSearchModel();
            firstColRenderCell = ism.getFirstColumnRenderCell();
         %>
         columns = <%=ism.getColumnsAsJson()%>;
         url = 'controller/caseIncidentSearch/incident.json';
         store = CPBDataGrid.createStore('incidentSearchGrid', url, true);
         SearchGrid.create(<%=firstColRenderCell%>, columns, 'incidentSearchGridDiv', {
            id: 'caseSearchGrid',
            columns: columns,
            store: store,
            rowsPerPage: <%=WebUtil.getPageSize()%>
         }).startup();
         
      });
   });
</script>
