<%@include file="/shell/default.jspf"%>
<%@taglib prefix="sas" uri="http://www.sas.com/taglib/sas" %>
<%@taglib prefix="sas-ui" uri="http://www.sas.com/taglib/sas-ui" %>
<%@taglib prefix="sas-cm" uri="http://www.sas.com/casemgmt/tag" %>
<%@taglib uri='http://struts.apache.org/tags-bean' prefix='bean' %>
<%@page import="java.util.*" %>
<%@page import="com.sas.solutions.casemgmt.web.entity.*"%>
<%@page import="com.sas.solutions.casemgmt.web.form.*"%>
<%@page import="com.sas.solutions.cpb.util.LabelValue"%>
<%@page import="com.sas.solutions.cpb.util.MiscUtil"%>
<%@page import="com.sas.fsd.shared.web.util.HTMLUtil"%>
<%@page import="java.text.SimpleDateFormat"%>
<%@ page import="com.sas.fsd.shared.util.StringUtil" %>

<%
ToDoListActionModel model = ToDoListActionModel.getFromRequest(request);
ToDoListForm tdForm = (ToDoListForm)request.getAttribute("ToDoListForm");
boolean readOnly = new Boolean(((Boolean)request.getAttribute("readOnly")).booleanValue()).booleanValue();
String readOnlyString = readOnly?", disabled:'disabled' ":"";
String promptMessage = "promptMessage: '"+ model.getPromptMessage()+"'";
String taskDescriptionString = tdForm.getTaskDescription();
if (taskDescriptionString == null)
   taskDescriptionString = "";

Integer tempHour = tdForm.getReminderHour();
Integer tempMinute = tdForm.getReminderMinute();

String hours = " options: [";
for (LabelValue labelValueBean : tdForm.getHours())
{
   boolean selected = false;
   if (tempHour != null)
   {
      selected = MiscUtil.areEquivalent(tdForm.getReminderHour().toString(), labelValueBean.getValue().toString());
   }
      
   hours += "{ label: '" + HTMLUtil.escapeHTML(labelValueBean.getLabel()) +"', value: '" + labelValueBean.getValue() + "'";   
   
   if (selected)
      hours += ", selected: true";       
      
   hours += "},";
}
hours = hours.substring(0, hours.length()-1) + "], "; // Remove trailing comma from array

String minutes = " options: [";
for (LabelValue labelValueBean : tdForm.getMinutes())
{
   boolean selected = false;
   if (tempMinute != null)
   {
      selected = MiscUtil.areEquivalent(tempMinute.toString(), labelValueBean.getValue().toString());
   }
   
   minutes += "{ label: '" + HTMLUtil.escapeHTML(labelValueBean.getLabel()) +"', value: '" + labelValueBean.getValue() + "'";   
   
   if (selected)
      minutes += ", selected: true";
   
   minutes += "},";
}
minutes = minutes.substring(0, minutes.length()-1) + "], "; // Remove trailing comma from array

String ampm = "";
if(!tdForm.isMilitaryTime()) {
   tdForm.setRequest(request);
   ampm = " options: [";
   for (Iterator iterator = tdForm.getAmpm().iterator(); iterator.hasNext();)
   {
      LabelValue labelValueBean = (LabelValue) iterator.next();
     
      final boolean selected = MiscUtil.areEquivalent(tdForm.getReminderAMPM(), labelValueBean.getValue().toString());
      
      ampm += "{ label: '" + HTMLUtil.escapeHTML(labelValueBean.getLabel()) +"', value: '" + labelValueBean.getValue() + "'";   
      
      if (selected)
         ampm += ", selected: true }";
      else
         ampm += "}";        
      
      if (iterator.hasNext())
         ampm += ",";
   }
   ampm += "], ";
}
%>

<script type="text/javascript">
ToDoListGrid.FORM_NAME = "<%=StringUtil.escapeJSForHTML(model.getFormName())%>";

Event.observe(window, "load", ToDoListGrid.handleOnLoad);
</script>

<sas-cm:setBundle var="appResources" />

<%@include file="/ext/cpbcore/messages/ShowMessages.jsp" %>

<html:form method="post" action="/ToDo">
<div id="mainContent">
   <html:hidden property="rowId" styleId="rowId" />
   <html:hidden property="command" />
   <html:hidden property="transactionType" styleId="transactionType" />
   <html:hidden property="uiContextId" />
   <input type="hidden" name="ToDoListGrid.reminderDateTime" id="ToDoListGrid.reminderDateTime" value="${reminderDateTime}"/>
   <input type="hidden" name="ToDoListGrid.BOKey" id="boKey"  value="${boKey}"/>
   <input type="hidden" name="ToDoListGrid.BOName" id="boObj" value="${boName}"/>
   <div id="addPane">        
      <table width="100%">
         <tr>
            <td>
               <sas-ui:Prompt property="todoList.task_name.label.txt" required="true" />
            </td>
         </tr>
         <tr>
            <td><div id="taskDescription"></div></td>
         </tr>
         <tr>
            <td>
               <sas-ui:Prompt property="todoList.due_date.label.txt" required="true" />
            </td>
         </tr>
         <tr>
            <td><div id="dueDate"></div></td>
         </tr>
      </table>              
   </div>
   <BR>
   <div id="reminderPane">         
      <table width="50%">
         <tr>
            <td>
               <sas-ui:Prompt property="todoList.reminder_date_time.label.txt" required="false" />
            </td>
         </tr>
         <tr>
            <td><div id="reminderDateTime"></div>
            </td>
            <td>
               <div id='reminderHour'></div> : <div id='reminderMinute'></div> <div id='reminderAMPM'></div>
            </td>
         </tr>
      </table>   
   </div>
</div>

<% String dueDateString = ", value:'"+tdForm.getDueDate()+"'";
   String reminderDateString = ", value:'"+tdForm.getReminderDateTime()+"'";
%>

<script type='text/javascript'>
require(['dijit/form/ValidationTextBox', 'dijit/form/DateTextBox', 'dijit/form/Select', 'dojo/ready'],
      function(ValidationTextBox, DateTextBox, Select, ready) {
   ready(function() {
      
      var textBox = new ValidationTextBox({id:"taskDescription", name:"taskDescription",
         value:"<%=taskDescriptionString%>", size:"120", maxLength:"255"}, dojo.byId("taskDescription"));
      textBox.on('change', function(){ToDoListGrid.TaskName = (dojo.byId("taskDescription").value);});
      textBox.startup();
      
      var datePicker = new DateTextBox({id:'dueDate', name:'dueDate', <%=promptMessage%> <%=readOnlyString%> <%=dueDateString%>}, dojo.byId('dueDate'));
      datePicker.constraints.min = datePicker.value ? datePicker.value:new Date();
      datePicker.on('change', function(){ToDoListGrid.DueDate = (dojo.byId('dueDate').value);});
      datePicker.startup();
      
      var reminderDatePicker = new DateTextBox({id:'reminderDateTime', name:'reminderDateTime', <%=promptMessage%> <%=readOnlyString%> <%=reminderDateString%>}, dojo.byId('reminderDateTime'));
      reminderDatePicker.constraints.min = reminderDatePicker.value ? reminderDatePicker.value:new Date();
      reminderDatePicker.on('change', function(){ToDoListGrid.ReminderDateTime = (dojo.byId('reminderDateTime').value);});
      reminderDatePicker.startup();
      
      var reminderHour = new Select({id:'reminderHour', name:'reminderHour', maxHeight: '-1', <%=hours%> <%=readOnlyString%>}, dojo.byId('reminderHour'));
      reminderHour.on('change', function(){ToDoListGrid.ReminderHour = dijit.byId('reminderHour').get('value')});
      reminderHour.startup();
      
      var reminderMinute = new Select({id:'reminderMinute', name:'reminderMinute', maxHeight: '-1', <%=minutes%> <%=readOnlyString%>}, dojo.byId('reminderMinute'));
      reminderMinute.on('change', function(){ToDoListGrid.ReminderMinute = dijit.byId('reminderMinute').get('value')});                   
      reminderMinute.startup();

      var reminderAmPm = dojo.byId('reminderAMPM');
      if (<%=!tdForm.isMilitaryTime()%>) {
         var reminderAMPM = new Select({id:'reminderAMPM', name:'reminderAMPM', maxHeight: '-1', <%=ampm%> <%=readOnlyString%>}, dojoAmPm);
         reminderAMPM.on('change', function(){ToDoListGrid.ReminderAMPM = dijit.byId('reminderAMPM').get('value')});                   
         reminderAMPM.startup();
      }
   });
});
</script>

<div id="popupButtonBarContainer"><div id="popupButtonBar">
   <% model.writeGridButtonBar(out); %>
</div></div>
</html:form>